---
title: IDBCursor.direction
slug: Web/API/IDBCursor/direction
tags:
  - API
  - Database
  - IDBCursor
  - IndexedDB
  - Property
  - Reference
  - Storage
  - direction
---
<p>{{ APIRef("IndexedDB") }}</p>

<div>
<p>The <strong><code>direction</code></strong> read-only property of the {{domxref("IDBCursor")}} interface is a {{domxref("DOMString")}} that returns the direction of traversal of the cursor (set using {{domxref("IDBObjectStore.openCursor")}} for example). See the {{anch("Values")}} section below for possible values.</p>

<p>{{AvailableInWorkers}}</p>
</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate" style="font-size: 14px;">var <em>direction = cursor</em>.direction;</pre>

<h3 id="Value">Value</h3>

<p>A string (defined by the <a href="https://dvcs.w3.org/hg/IndexedDB/raw-file/default/Overview.html#idl-def-IDBCursorDirection"><code>IDBCursorDirection</code> enum</a>) indicating the direction in which the cursor is traversing the data. Possible values are:</p>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Value</th>
   <th scope="col">Description</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td><code>next</code></td>
   <td>This direction causes the cursor to be opened at the start of the <span class="internalDFN">source</span>.</td>
  </tr>
  <tr>
   <td><code>nextunique</code></td>
   <td>This direction causes the cursor to be opened at the start of the <span class="internalDFN">source</span>. For every key with duplicate values, only the first record is yielded.</td>
  </tr>
  <tr>
   <td><code>prev</code></td>
   <td>This direction causes the cursor to be opened at the end of the <span class="internalDFN">source</span>.</td>
  </tr>
  <tr>
   <td><code>prevunique</code></td>
   <td>This direction causes the cursor to be opened at the end of the <span class="internalDFN">source</span>. For every key with duplicate values, only the first record is yielded.<br>
     </td>
  </tr>
 </tbody>
</table>

<h2 id="Example">Example</h2>

<p>In this simple fragment we create a transaction, retrieve an object store, then use a cursor to iterate through all the records in the object store. Within each iteration we log the direction of the cursor, something like this:</p>

<pre class="language-html notranslate" style="padding: 1em 0px 1em 30px; font-size: 14px; color: rgb(77, 78, 83);"><code class="language-html" style="font-family: Consolas, Monaco, 'Andale Mono', monospace; direction: ltr;">prev</code></pre>

<div class="line-number" style="margin-top: 1em; position: absolute; left: 0px; right: 0px; line-height: inherit; top: 0px; background: 0px 0px;"></div>

<div class="note">
<p><strong>Note</strong>: we can't change the direction of travel of the cursor using the <code>direction</code> property, as it is read-only. We specify the direction of travel using the 2nd argument of {{domxref("IDBObjectStore.openCursor")}}.</p>
</div>

<p>The cursor does not require us to select the data based on a key; we can just grab all of it. Also note that in each iteration of the loop, you can grab data from the current record under the cursor object using <code>cursor.value.foo</code>. For a complete working example, see our <a class="external external-icon" href="https://github.com/mdn/indexeddb-examples/tree/master/idbcursor">IDBCursor example</a> (<a class="external external-icon" href="https://mdn.github.io/indexeddb-examples/idbcursor/">view example live</a>.)</p>

<pre class="brush: js notranslate">function backwards() {
  list.textContent = '';
  const transaction = db.transaction(['rushAlbumList'], 'readonly');
  const objectStore = transaction.objectStore('rushAlbumList');

  objectStore.openCursor(null,'prev').onsuccess = function(event) {
    const cursor = event.target.result;
      if(cursor) {
        const listItem = document.createElement('li');
        listItem.innerHTML = '&lt;strong&gt;' + cursor.value.albumTitle + '&lt;/strong&gt;, ' + cursor.value.year;
        list.appendChild(listItem);

        console.log(cursor.direction);
        cursor.continue();
      } else {
        console.log('Entries displayed backwards.');
      }
  };
};</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('IndexedDB', '#dom-idbcursor-direction', 'direction')}}</td>
   <td>{{Spec2('IndexedDB')}}</td>
   <td></td>
  </tr>
  <tr>
   <td>{{SpecName("IndexedDB 2", "#dom-idbcursor-direction", "direction")}}</td>
   <td>{{Spec2("IndexedDB 2")}}</td>
   <td></td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.IDBCursor.direction")}}</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/IndexedDB_API/Using_IndexedDB">Using IndexedDB</a></li>
 <li>Starting transactions: {{domxref("IDBDatabase")}}</li>
 <li>Using transactions: {{domxref("IDBTransaction")}}</li>
 <li>Setting a range of keys: {{domxref("IDBKeyRange")}}</li>
 <li>Retrieving and making changes to your data: {{domxref("IDBObjectStore")}}</li>
 <li>Using cursors: {{domxref("IDBCursor")}}</li>
 <li>Reference example: <a class="external" href="https://github.com/mdn/to-do-notifications/tree/gh-pages">To-do Notifications</a> (<a class="external" href="https://mdn.github.io/to-do-notifications/">view example live</a>.)</li>
</ul>
